// Copyright (C) 2004, Brian Enigma <enigma at netninja.com>
// This file is part of iGallery.
//
// iGallery is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// iGallery is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Foobar; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
package org.ninjasoft.igallery.data;

import java.util.*;

/**
 * Simple bean to wrap album information
 * @author enigma
 */
public class GalleryAlbum {
    private int refNumber = 0;
    private String name = "";
    private String title = "";
    private String summary = "";
    private String parent = "";
    private GalleryAlbum parentAlbum = null;
    private Vector images = null;
    
    public String toString() {
        StringBuffer result = new StringBuffer();
        if (parentAlbum != null) {
            result.append(parentAlbum.toString());
            result.append(" / ");
        }
        result.append(Integer.toString(refNumber));
        result.append(":");
        result.append(name);
        return result.toString();
    }
    
	/**
	 * @return Returns the name.
	 */
	public String getName() {
		return name;
	}
	/**
	 * @param name The name to set.
	 */
	public void setName(String name) {
		this.name = name;
	}
	/**
	 * @return Returns the parent.
	 */
	public String getParent() {
		return parent;
	}
	/**
	 * @param parent The parent to set.
	 */
	public void setParent(String parent) {
		this.parent = parent;
	}
	/**
	 * @return Returns the refNumber.
	 */
	public int getRefNumber() {
		return refNumber;
	}
	/**
	 * @param refNumber The refNumber to set.
	 */
	public void setRefNumber(int refNumber) {
		this.refNumber = refNumber;
	}
	/**
	 * @return Returns the summary.
	 */
	public String getSummary() {
		return summary;
	}
	/**
	 * @param summary The summary to set.
	 */
	public void setSummary(String summary) {
		this.summary = summary;
	}
	/**
	 * @return Returns the title.
	 */
	public String getTitle() {
		return title;
	}
	/**
	 * @param title The title to set.
	 */
	public void setTitle(String title) {
		this.title = title;
	}
	/**
	 * @return Returns the parentAlbum.
	 */
	public GalleryAlbum getParentAlbum() {
		return parentAlbum;
	}
	/**
	 * @param parentAlbum The parentAlbum to set.
	 */
	public void setParentAlbum(GalleryAlbum parentAlbum) {
		this.parentAlbum = parentAlbum;
	}
    
    public void addPicture(GalleryImage i) {
        if (images == null)
            images = new Vector();
        this.images.add(i);
    }
    public void addPictures(Collection c) {
        if (images == null)
            images = new Vector();
        this.images.addAll(c);
    }
    public Vector getPictures() {
        if (images == null)
            images = new Vector();
        return this.images;
    }
    public int getPictureCount() {
        if (images != null)
        	return this.images.size();
        return -1;
    }
}
