// Copyright (C) 2004, Brian Enigma <enigma at netninja.com>
// This file is part of iGallery.
//
// iGallery is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// iGallery is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Foobar; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
package org.ninjasoft.igallery.swingui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

/**
 * @author enigma
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class PanelBuilder {
    public static JPanel createLoginPanel(  JTextField urlText,
											JTextField usernameText,
											JPasswordField passwordText,
											JButton loginButton,
                                            JCheckBox debugCheckbox) {
        JPanel panel = new JPanel();
        panel.setLayout(new GridBagLayout());
        panel.setBorder(BorderFactory.createEmptyBorder(20, 20, 0, 20));
        GridBagConstraints c = new GridBagConstraints();
        c.insets = new Insets(3, 3, 3, 3);
        c.gridx = c.gridy = 0;
        c.gridwidth = c.gridheight = 1;
        c.weighty = 1;
        c.weightx = 1;
        c.anchor = GridBagConstraints.EAST;
        c.fill = GridBagConstraints.NONE;
        panel.add(new JLabel("Gallery URL:"), c);
        c.gridx++;
        c.weightx = 6;
        c.anchor = GridBagConstraints.WEST;
        c.fill = GridBagConstraints.HORIZONTAL;
        panel.add(urlText, c);
        c.gridx = 0;
        c.gridy++;
        c.weightx = 1;
        c.anchor = GridBagConstraints.EAST;
        c.fill = GridBagConstraints.NONE;
        panel.add(new JLabel("Username:"), c);
        c.gridx++;
        c.weightx = 6;
        c.anchor = GridBagConstraints.WEST;
        c.fill = GridBagConstraints.HORIZONTAL;
        panel.add(usernameText, c);
        c.gridx = 0;
        c.gridy++;
        c.weightx = 1;
        c.anchor = GridBagConstraints.EAST;
        c.fill = GridBagConstraints.NONE;
        panel.add(new JLabel("Password:"), c);
        c.gridx++;
        c.weightx = 6;
        c.anchor = GridBagConstraints.WEST;
        c.fill = GridBagConstraints.HORIZONTAL;
        panel.add(passwordText, c);
        c.gridx = 0;
        c.gridy++;
        c.weightx = 1;
        c.gridwidth = 1;
        c.anchor = GridBagConstraints.WEST;
        c.fill = GridBagConstraints.NONE;
        panel.add(debugCheckbox, c);
        c.gridx++;
        c.weightx = 1;
        c.gridwidth = 1;
        c.anchor = GridBagConstraints.EAST;
        c.fill = GridBagConstraints.NONE;
        panel.add(loginButton, c);
        c.gridx = 0;
        c.gridy++;
        c.weightx = 1;
        c.gridwidth = 2;
        c.anchor = GridBagConstraints.CENTER;
        c.fill = GridBagConstraints.HORIZONTAL;
        panel.add(new JSeparator(), c);
        return panel;
    }
    public static JPanel createLists(JTable iPhotoTable, JTable galleryTable) {
        JPanel panel = new JPanel();
        panel.setBorder(BorderFactory.createEmptyBorder(0, 20, 0, 20));
        panel.setLayout(new GridBagLayout());
        GridBagConstraints c = new GridBagConstraints();
        c.insets = new Insets(3, 3, 3, 3);
        c.gridx = c.gridy = 0;
        c.weightx = 0;
        c.weighty = 0;
        c.anchor = GridBagConstraints.WEST;
        c.fill = GridBagConstraints.NONE;
        c.gridwidth = 1;
        c.gridheight = 1;
        panel.add(new JLabel("iPhoto Albums"), c);
        c.gridx += 2;
        panel.add(new JLabel("Gallery Albums"), c);
        c.gridx = 0;
        c.gridy++;
        c.weightx = 3;
        c.weighty = 3;
        c.anchor = GridBagConstraints.CENTER;
        c.fill = GridBagConstraints.BOTH;
        panel.add(new JScrollPane(iPhotoTable), c);
        c.gridx++;
        c.weightx = 1;
        c.weighty = 3;
        c.anchor = GridBagConstraints.CENTER;
        c.fill = GridBagConstraints.VERTICAL;
        panel.add(new JLabel(new ImageIcon(PanelBuilder.class.getResource("/org/ninjasoft/igallery/swingui/images/arrow.gif"))), c);
        c.gridx++;
        c.weightx = 3;
        c.weighty = 3;
        c.anchor = GridBagConstraints.CENTER;
        c.fill = GridBagConstraints.BOTH;
        panel.add(new JScrollPane(galleryTable), c);
        return panel;
    }
    public static JPanel createButtons(JTextArea status, JButton compareButton, JButton uploadButton) {
        JPanel panel = new JPanel();
        panel.setBorder(BorderFactory.createEmptyBorder(0, 20, 20, 20));
        panel.setLayout(new GridBagLayout());
        GridBagConstraints c = new GridBagConstraints();
        c.insets = new Insets(3, 3, 3, 3);
        c.gridx = c.gridy = 0;
        c.weightx = 4;
        c.weighty = 1;
        c.anchor = GridBagConstraints.WEST;
        c.fill = GridBagConstraints.HORIZONTAL;
        c.gridwidth = 1;
        c.gridheight = 2;
        JScrollPane scrolly = new JScrollPane(status, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        scrolly.setOpaque(false);
        panel.add(scrolly, c);
        
        int width = Math.max(compareButton.getWidth(), uploadButton.getWidth());
        compareButton.setSize(width, compareButton.getHeight());
        uploadButton.setSize(width, uploadButton.getHeight());
        
        c.weightx = 1;
        c.weighty = 1;
        c.gridwidth = 1;
        c.gridheight = 1;
        c.gridy = 0;
        c.gridx++;
        c.fill = GridBagConstraints.HORIZONTAL;
        c.anchor = GridBagConstraints.SOUTHEAST;
        panel.add(compareButton, c);
        c.gridy++;
        c.anchor = GridBagConstraints.NORTHEAST;
        panel.add(uploadButton, c);
        return panel;
    }
}
